import { Service } from "./service";
import * as express from "express";
export interface Request extends express.Request {
}
export interface Response extends express.Response {
}
export declare abstract class RouteService extends Service {
    routes: Route<any>[];
    prefix: string;
    addRoute(RouteHandler: any): void;
    install(server: express.Application): void;
}
export declare abstract class Route<TMIME extends MIME> {
    service: RouteService;
    constructor(service: RouteService);
    name: string;
    mime: TMIME;
    abstract path: string;
    method: METHOD;
    params: {};
    body: {};
    query: {};
    next: Function;
    req: Request;
    res: Response;
    handleRawRequest(req: any, res: any, next: any): void;
    end(content: any): void;
    abstract handle(): any;
}
export declare abstract class DynamicResourceRoute<T extends MIME> extends Route<T> {
}
export declare abstract class PageRoute extends Route<"text/html"> {
    html(content: string): void;
}
export declare abstract class APIRoute extends Route<"application/json"> {
    success(data: any): void;
    error(err: Error): void;
    json(data: any): void;
}
export declare type MIME = "text/html" | "text/javascript" | "text/json" | "application/json" | string;
export declare type METHOD = "GET" | "POST" | "DELETE" | "PUT";
