import { DependencyManager } from "./dependency";
export declare class ServiceContext {
    services: {
        [index: string]: Service;
    };
    dependencyManager: DependencyManager;
    register(s: Service): void;
    supportedLoadExtnames: string[];
    loadServices(path: string): void;
    loadService(path: string): void;
    setup(finish?: (err?: Error) => void): void;
}
export declare abstract class Service {
    abstract name: string;
    dependencies: string[];
    abstract initialize(deps: {
        [index: string]: Service;
    }, done?: (err?: Error) => void): any;
}
